aboutsummaryrefslogtreecommitdiffstats
path: root/community/i2pd/i2pd.initd
diff options
context:
space:
mode:
Diffstat (limited to 'community/i2pd/i2pd.initd')
-rw-r--r--community/i2pd/i2pd.initd51
1 files changed, 51 insertions, 0 deletions
diff --git a/community/i2pd/i2pd.initd b/community/i2pd/i2pd.initd
new file mode 100644
index 00000000000..268e4151fb4
--- /dev/null
+++ b/community/i2pd/i2pd.initd
@@ -0,0 +1,51 @@
+#!/sbin/openrc-run
+# Copyright 1999-2016 Gentoo Foundation
+# Copyright 2018 l-n-s <supervillain@riseup.net>
+# Distributed under the terms of the GNU General Public License v2
+
+description="C++ daemon for accessing the I2P network"
+description_graceful="Graceful shutdown, takes 10 minutes"
+
+command="/usr/sbin/i2pd"
+command_args="${I2PD_OPTIONS}"
+user="${I2PD_USER}:${I2PD_GROUP}"
+start_stop_daemon_args="
+ --user \"${user}\"
+ --pidfile \"${I2PD_PID}\"
+ --progress
+"
+retry="SIGTERM/20/SIGKILL/20"
+
+I2PD_PID_DIR=$(dirname "${I2PD_PID}")
+
+extra_started_commands="graceful"
+
+depend() {
+ need net
+ after firewall
+ use dns logger netmount
+}
+
+start_pre() {
+ if [ -z "${I2PD_USER}" ] || \
+ [ -z "${I2PD_GROUP}" ] || \
+ [ -z "${I2PD_PID}" ] || \
+ [ -z "${I2PD_OPTIONS}" ] ; then
+ eerror "Not all variables I2PD_USER, I2PD_GROUP, I2PD_PID, I2PD_OPTIONS are defined."
+ eerror "Check your /etc/conf.d/i2pd."
+ return 1
+ fi
+ if [ -n "${I2PD_LOG}" ]; then
+ checkpath -f -o "${user}" "${I2PD_LOG}"
+ fi
+ checkpath -d -m 0750 -o "${user}" "${I2PD_PID_DIR}"
+}
+
+graceful() {
+ # on SIGINT, i2pd stops accepting tunnels and shuts down in 600 seconds
+ ebegin "Gracefully stopping i2pd, this takes 10 minutes"
+ mark_service_stopping
+ eval start-stop-daemon --stop ${start_stop_daemon_args} \
+ --exec "${command}" --retry 'SIGINT/620/SIGTERM/20/SIGKILL/20'
+ eend $? && mark_service_stopped
+}